# Ballance Blender Plugin User Manual

!!! info "May be Outdated"
    This document is translated from other languages and may not always be up to date.

Welcome to the Ballance Blender Plugin, the user manual for the free and open source Ballance map creation suite.

Ballance Blender Plugin (aka BBP) is a plugin that focuses on the creation of Ballance custom maps. It offers a wide range of features that can be used to create Ballance maps by anyone from novice to experienced mappers. BBP provides the ability to import and export formats used in Ballance maps, and a series of convenient features tailored to the creation of Ballance maps: for novice mappers, you can quickly assemble a map with prefabricated road blocks, and for the experienced mappers, the mapping tools needed to build complex structures are also provided.

Compared to other mapping processes, the mapping process with Blender and BBP has unparalleled advantages. First of all, both Blender and BBP are free and open source, unlike 3ds Max and Virtools, which require payment. Secondly, Blender and BBP are still actively updated and therefore run perfectly on today's computer systems, whereas 3ds Max and Virtools only run on certain legacy versions or even 32-bit versions because Virtools is no longer updated, and because of this 3ds Max and Virtools can crash in a variety of ways on today's systems.

Therefore, choosing Blender with BBP for mapping is not only choosing freedom and open source, but also choosing the easiest way of mapping in today's status quo.

## Getting Started

* [Install Plugin](./install-plugin.md)
* [Configure Plugin](./configure-plugin.md)

## Features

* [Virtools Properties](./virtools-properties.md)
* [Ballance Properties](./ballance-properties.md)
* [Import and Export Virtools Document](./import-export-virtools.md)
* [Group Operation](./group-operations.md)
* [Legacy Alignment](./legacy-align.md)
* [Naming Convention](./naming-convention.md)
* [UV Mapping](./uv-mapping.md)
* [Add Floor](./bme-adder.md)
* [Add Rail](./rail-adder.md)
* [Add Component](./component-adder.md)

## Misc

* [Compile and Distribute Plugin](./compile-distribute-plugin.md)
* [Report Issue](./report-bugs.md)
* [Technical Information](./tech-infos.md)

!!! info "These are not all"
    This manual only documents the relevant operations regarding this plugin and does not explain how to make a Ballance map here. For detailed information on how to make a Ballance map with Blender and BBP, please search for content on Bilibili or YouTube.
