# Ballance Blender Plugin用户手册

欢迎来到Ballance Blender Plugin，一个自由开源的Ballance地图创作套件的用户手册。

Ballance Blender Plugin（后文简称BBP）是一款关注Ballance自制地图创建的插件。它提供了相当丰富的功能，从制图新手到老手，均可利用此插件创作Ballance自制地图。BBP提供了导入导出Ballance地图所用格式的功能，并为Ballance地图创作量身打造了一系列便利的功能：对于新手，可以借助预制路块快速拼接完成一张地图；对于老手，也提供了构建复杂结构所需的贴图工具。

相比于其它制图流程，借助Blender与BBP的制图流程具有无可比拟的优势。首先Blender与BBP均是免费开源的，这与3ds Max及Virtools等需要付费的软件大不相同。其次，Blender与BBP仍处于活跃更新中，因而可以在当代的计算机系统上完美运行；而3ds Max与Virtools则由于Virtools不再更新，只能运行在某些特定的上古版本，甚至是只能以32位运行，也正因为如此，3ds Max与Virtools在当今系统上运行会出现各种各样的崩溃行为。

因此，选择Blender配合BBP进行制图，不仅仅是选择了自由与开源，更是选择了当今现状下最轻松的制图道路。

## 入门

* [安装插件](./install-plugin.md)
* [配置插件](./configure-plugin.md)

## 特性

* [Virtools属性](./virtools-properties.md)
* [Ballance属性](./ballance-properties.md)
* [导入导出Virtools文档](./import-export-virtools.md)
* [按组操作](./group-operations.md)
* [传统对齐](./legacy-align.md)
* [命名规则](./naming-convention.md)
* [UV贴图](./uv-mapping.md)
* [添加路面](./bme-adder.md)
* [添加钢轨](./rail-adder.md)
* [添加机关](./component-adder.md)

## 其它

* [编译与分发插件](./compile-distribute-plugin.md)
* [报告问题](./report-bugs.md)
* [技术信息](./tech-infos.md)

!!! info "这些并不是全部"
    本手册只记录有关此插件的相关操作，并不会在此说明如何制作一份Ballance地图。如需详细了解如何利用Blender和BBP制作Ballance地图，请在Bilibili或YouTube上搜索相关内容。
